﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TelemetryIO
{
    public partial class RatePID : UserControl
    {
        private float[] pid0 = new float[9];
        private float[] pid1 = new float[9];
        private float zh = 0;
        private bool isSubscribed = false;
        public SerialHandler serial { get; set; }
        public Label bottom_label { get; set; }

        public RatePID()
        {
            InitializeComponent();
            Debug.Write("tab elements = " + tabControl1.TabPages[0].Controls[0].Controls);
        }

        private void Serial_AnswerReceived(object sender, SerialEventArgs e)
        {
            if (bottom_label.InvokeRequired)
            {
                bottom_label.BeginInvoke(new Action(() => bottom_label.Text = e.Answer)); // Асинхронный вызов
            }
            else
            {
                bottom_label.Text = e.Answer; ;
            }
        }

        public void SubscribeOnEvent(SerialHandler s)
        {
            if (isSubscribed) return;
            isSubscribed = true;
            serial = s;
            serial.AnswerReceived += Serial_AnswerReceived;
        }

        private void Save_btn_Click(object sender, EventArgs e)
        {
            
            float[] floats = new float[9];
            for(int i = 0; i < pid0_panel.Controls.Count; i++)
            {
                if (pid0_panel.Controls[i] is NumericUpDown)
                {
                    NumericUpDown c = pid0_panel.Controls[i] as NumericUpDown;
                    floats[pid0_panel.Controls[i].TabIndex - 1] = (float)c.Value;
                }
            }
            serial.sendTestWrite(floats);
        }
    }
}
